!+
! Module: imsetwcs_mod
!
! Authors:  Ian Stewart - JBO
!          
! Description: Contains several tasks to help make simulated x-ray images.
! 
! Comments: 
! 
! $Id: module.f90,v 1.6 1998/05/27 13:45:39 gvacanti Exp $
!- 
module imsetwcs_mod

  use dal
  use param  
  use errorHandling

  use wcs_aux
!use l_wcs_aux

  implicit none 

  private 

  ! Command-line parameters:
  type(WcsT) ::&
    wcs
  character(256) ::&
    imageSetName=''


  public imsetwcs

contains 

  !---------------------------------------------------------------------
  subroutine imsetwcs
  !---------------------------------------------------------------------

    implicit none

    real(double) :: rotAngle, xPixelSizeWorld, yPixelSizeWorld
    type(DataSetT) :: set
    type(ArrayT) :: inArray

    !-------------------------------------------------------------------
    ! Start

    wcs%x%ctype     = stringParameter('xctype')
    wcs%x%worldUnit = stringParameter('xcunit')
    wcs%x%refPixels = realParameter('xrefpixel')
    wcs%x%refWorld  = realParameter('xrefworld')
    xPixelSizeWorld = realParameter('xdeltaworld')
    wcs%y%ctype     = stringParameter('yctype')
    wcs%y%worldUnit = stringParameter('ycunit')
    wcs%y%refPixels = realParameter('yrefpixel')
    wcs%y%refWorld  = realParameter('yrefworld')
    yPixelSizeWorld = realParameter('ydeltaworld')

    rotAngle        = realParameter('rotangle')

    imageSetName    = stringParameter('imageset')

    call convertOldToNew(xPixelSizeWorld, yPixelSizeWorld, rotAngle, wcs)
    ! in ssclib/wcs_aux.

    set = dataSet(imageSetName, MODIFY)
    inArray = array(set, 0)
    call writeWcs(inArray, wcs) ! in ssclib/wcs_aux.
    call release(inArray)
    call release(set)

  end subroutine imsetwcs

  !---------------------------------------------------------------------
  subroutine template
  !---------------------------------------------------------------------

    implicit none

    !-------------------------------------------------------------------
    ! Start

  end subroutine template

end module imsetwcs_mod
