!+
! Module: newcolgen_mod
!
! Authors:  Ian Stewart - JBO
!          
! Description: Creates new columns in a FITS binary table.
! 
! Comments: 
! 
! $Id: module.f90,v 1.6 1998/05/27 13:45:39 gvacanti Exp $
!- 
module newcolgen_mod

  use dal
  use param  
  use errorHandling

  use dal_aux

  implicit none 

  private 

  ! Command-line parameters:

  public newcolgen

contains 

  !---------------------------------------------------------------------
  subroutine newcolgen
  !---------------------------------------------------------------------

    implicit none

    character(255) :: setTabName, setName, tabName
    integer(int16) :: numNewCols, newColNum

    type(DataSetT) :: set
    type(TableT) :: tab
    type(ColumnT) :: dataValCol
    integer(int32), pointer :: dataVals(:)
!    integer(int32) :: numSelRows
    character(255) :: colName
    integer(int32) :: colValue

    !-------------------------------------------------------------------
    ! Start

    setTabName = stringParameter('tab')
    numNewCols = parameterCount('newcolumnlist')
    if (numNewCols .ne. parameterCount('newcolvaluelist'))&
call error('columnListMismatch','')
  if (numNewCols <= 0) return

    call splitSetTabName(setTabName, setName, tabName) ! in ssclib/dal_aux.

    set = dataSet(setName, MODIFY)
    tab = table(set, tabName)

    do newColNum = 1, numNewCols
      colName = stringParameter('newcolumnlist', newColNum-1)
      colValue = intParameter('newcolvaluelist', newColNum-1)

!****** should change this interface to make it much more general. Make it similar to addattribute.

      dataValCol = addOrOpenColumn(tab, colName, INTEGER32)
      dataVals => int32Data(dataValCol)
      dataVals = colValue
      call release(dataValCol)
    end do

    call release(tab)
    call release(set)

  end subroutine newcolgen

  !---------------------------------------------------------------------
  subroutine template
  !---------------------------------------------------------------------

    implicit none

    !-------------------------------------------------------------------
    ! Start

  end subroutine template

end module newcolgen_mod
