!+
! Module: plot_types
!
! Authors:  Ian Stewart - SSC/LUX
!          
! Description: Contains mostly type definitions for plotlib.
! 
! Comments: TODO:
! 
! $Id: module.f90,v 1.6 1998/05/27 13:45:39 gvacanti Exp $
!- 
module l_plot_types

  use types

!  use constants
!  use linear
!  use array_utils	! for largestTrueIndex().

  implicit none 

  private 

  integer, public, parameter ::&
!    localNumColourPoints = 256,&
!    numReservedClrs = 3,&
    red = 1,&
    grn = 2,&
    blu = 3

  type, public :: colourType
    real :: hue(3)
  end type colourType
  type, public :: localRangeType
    real :: lo, hi
  end type localRangeType
  type, public :: boxFieldType
    type(localRangeType) :: x, y
  end type boxFieldType

  real, public, dimension(6) ::&
    pgTrMatrix = (/0.0, 1.0, 0.0, 0.0, 0.0, 1.0/)

  public inBoxField

contains 

  !---------------------------------------------------------------------
  logical function inBoxField(x, y, box)
  !---------------------------------------------------------------------

    implicit none

    real, intent(in) :: x, y
    type(boxFieldType), intent(in) :: box

    !-------------------------------------------------------------------
    ! Start

    inBoxField = .false. ! default
    if (x>=box%x%lo .and. x<box%x%hi .and. y>=box%y%lo .and. y<box%y%hi)&
      inBoxField = .true.

  end function inBoxField

  !---------------------------------------------------------------------
  subroutine template
  !---------------------------------------------------------------------

    implicit none

    !-------------------------------------------------------------------
    ! Start

  end subroutine template

end module l_plot_types
